'use strict';

const St = imports.gi.St
const Main = imports.ui.main
const GLib = imports.gi.GLib
const Util = imports.misc.util

const executeAction = (action) => Util.spawn(['playerctl', action])

const PANEL_POSITON = 2
const BUTTONS = [
  {
    icon: 'media-skip-forward-symbolic',
    action: 'next',
  },
  {
    icon: 'media-playback-pause-symbolic',
    action: 'play-pause',
  },
  {
    icon: 'media-skip-backward-symbolic',
    action: 'previous',
  },
]

const buttons = BUTTONS.map(({icon, action}) => {
  return {
    action: () => executeAction(action),
    element: new St.Button({ style_class: 'panel-button' }),
    icon: new St.Icon({
      style_class: 'system-status-icon',
      icon_name: icon,
    }),
  }
})

function init() {
  buttons.forEach((button) => {
    button.element.set_child(button.icon)
    button.element.connect('button-press-event', button.action)
  })
}

function enable() {
  buttons.forEach(({ element }) => Main.panel._rightBox.insert_child_at_index(element, PANEL_POSITON))
}

function disable() {
  buttons.forEach(({ element }) => Main.panel._rightBox.remove_child(element))
}
